<script lang="ts">
    /**
     * The grid of hexagonal fields on the district view
     */
    import { onMount } from 'svelte'
    import { createEventDispatcher } from 'svelte'
    import Map from 'lib/map/Map'

    const dispatch = createEventDispatcher()

    let map: Map
    let stage: HTMLElement
    let canvas: HTMLCanvasElement

    onMount(() => {
        window.requestAnimationFrame(draw)
    })

    const draw = () => {
        map = new Map({
            canvas,
            canvasWidth: stage.clientWidth,
        })
    }

    const hover = event => {
        map.hover(event)
    }

    const resize = () => {
        window.requestAnimationFrame(draw)
    }
</script>

<svelte:window on:resize={resize} />

<div class="stage" bind:this={stage}>
    <canvas
        bind:this={canvas}
        on:mousemove={hover}
        on:click={() => dispatch('selectField', map.hovered)}
    >
        You should use a browser accepting canvas to play the game
    </canvas>
</div>

<style lang="postcss">
    .stage {
        @apply relative col-span-4 w-full h-full;
    }
</style>
